﻿Type=Class
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
'code to put in main
'************************************************************
' declare a Phone object	
' declare your DEDialogs object in globals
'
'Initialize and AddView in Sub Activity_Resume :
'
'DED.Initialize("Main", False, 24 ,18,Activity)
'
'Add a Sub In the calling activity :
'Sub Hide_Keyboard
'Phone.HideKeyboard(Activity)
'End Sub

' ver 1.4 includes correction to the line height for various devices size
'
'*************************************************************************
Sub Class_Globals
Private  FilterIsString, Multi, PathFlag, input_flag, sortbydate, sortdirection  As Boolean
Private btn(2) As Button
Private inputet As EditText
Private scale, SF , xs As Float
Private dw(2), notdr, seldr, indw As GradientDrawable
Private result ,selected = -1 As Int 
Private AW, AH, fontsize, IH, SelTextColor , NotTextColor As Int
Private dw1clr(2), dw2clr(2),notclr(2), selclr(2) As Int
Private intextcolor As Int
Private titlelbl, uplbl As Label 
Private Flist, FilterList, SelList, NumList As List
Private MModule As Object
Private background,frame , p, line  As Panel
Private Phone As Phone
Private SV As ScrollView
Private ret, current_dir, F_Filter As String
Private Cf As Double

Type FileAndTime(Name As String, Time As Long)
End Sub

'Initializes the object.
'Module - the sending activity
'Fullpath - if the reult required as full path or just the file name.
'TitleSize and TextSize are font sizes.
'For activity Width and Height pass 100%x and 100%y.
Public Sub Initialize(Module As Object, FullPath As Boolean, TitleSize As Int,TextSize As Int, Parent As Activity)

AW = Parent.Width
AH = Parent.Height
SF =  Max(AW,AH)/800
scale = SF
Dim lv As LayoutValues
lv = GetDeviceLayoutValues
Dim xs As Float = lv.ApproximateScreenSize
Cf =  Sqrt((100%y * 100%y + 100%x * 100%x)/(Power(430 * Density,2) + Power(800 * Density,2))) * 1.4
MModule = Module
PathFlag = FullPath
fontsize = TextSize * Cf '*scale*scale

background.Initialize("background")
background.Color = Colors.ARGB(170,0,0,0)
background.Visible = False ' the panel that holds the whole dialog
Parent.AddView(background,0,0,100%x,100%y)
frame.Initialize("")
frame.Color = Colors.darkgray

p.Initialize("")
p.Color = Colors.rgb(70,70,70)

line.Initialize("")
line.Color = Colors.black

titlelbl.Initialize("")
titlelbl.TextSize = TitleSize * Cf '* scale
titlelbl.Textcolor = Colors.yellow
titlelbl.Gravity = Gravity.LEFT

NotTextColor = Colors.black
SelTextColor = Colors.yellow
uplbl.Initialize("uplbl")
uplbl.Text = "  • •"
uplbl.TextSize = TitleSize * Cf '* scale
uplbl.Textcolor = NotTextColor
uplbl.Visible = False

SV.Initialize(1500*scale)
IH = 80* Cf * scale  ' item (line) height
Flist.Initialize  ' filtered files list
SelList.Initialize  ' selected files list
NumList.Initialize   ' selected files numbers in the list

dw1clr(0) = Colors.white
dw1clr(1) = Colors.RGB(100,100,255)
dw(0).Initialize("TOP_BOTTOM",dw1clr) ' default gradient from white to dark gray
dw(0).CornerRadius = 5
indw.Initialize("TOP_BOTTOM",Array As Int(dw1clr(0),dw1clr(0)))  ' for the inputet
indw.CornerRadius = 5

dw2clr(0) = Colors.white
dw2clr(1) = Colors.RGB(255,100,100)
dw(1).Initialize("TOP_BOTTOM",dw2clr) ' default gradient from white to darg gray
dw(1).CornerRadius = 5

notclr(0) = Colors.white  
notclr(1) = Colors.darkgray
notdr.Initialize("TOP_BOTTOM",notclr) ' default for non selected - white on black

selclr(0) = Colors.gray 
selclr(1) = Colors.black 
seldr.Initialize("TOP_BOTTOM",selclr) ' default for selected - black on white

For i = 0 To 1
	btn(i).Initialize("button")
	btn(i).background = dw(i)
	btn(i).TextSize = fontsize 'TitleSize * scale
	btn(i).Textcolor = Colors.black
Next
btn(0).Tag = DialogResponse.POSITIVE
btn(1).Tag = DialogResponse.CANCEL
btn(0).Text = "OK"
btn(1).Text = "Cancel"

intextcolor = Colors.black
inputet.Initialize("")
inputet.background = indw
inputet.TextColor = intextcolor
inputet.TextSize = fontsize  'TitleSize * scale
inputet.Gravity = Gravity.BOTTOM

'The exact layout in the following is not important since all layouts are set later
background.AddView(frame,AW/2-200*scale, AH/2-200*scale, 400*scale, 400*scale)
frame.AddView(p,5*scale, 5*scale,390*scale,390*scale)
p.AddView(uplbl,5*scale,5*scale,55*scale,40*scale)
p.AddView(titlelbl,65*scale,5*scale,320*scale,40*scale)
p.AddView(line,0,50*scale,p.Width,3*scale)
p.AddView(SV,5*scale,60*scale + IH,380*scale,250*scale - IH)
p.AddView(btn(0),5*scale,p.Height - 55*scale,195*scale,50*scale)
p.AddView(btn(1),205*scale,p.Height - 55*scale,195*scale,50*scale)
p.AddView(inputet,10*scale ,57*scale,373*scale ,IH)

sortbydate = True
sortdirection = False
End Sub

'Increase or decrease the size of the whole dialog, stays centered. SizeFactor = 1 for the default.
Public Sub SetScale(SizeFactor As Float)
scale = SF * SizeFactor
End Sub

'Sets the text on the Ok and Cancel buttons, to change from the default.
Public Sub SetButtonsText(ok As String, cancel As String)
btn(0).Text = ok
btn(1).Text = cancel
End Sub

'Shows the dialog and enables one file selection and browsing.
'Dir - the directory where the list of files is taken from.
'Filter - can be a single string (with the file's extension), or a list of several possible extensions.
'Browse - true if browsing is possible(a button for going up and display of directories).
'The returned value is the file name.
'Cancel returns DialogResponse.CANCEL
Public Sub GetSingleFile(Dir As String, Filter As Object, Browse As Boolean) As String

Multi = False
input_flag = False
titlelbl.Text = "Get File"
Show_Common(Dir, Filter , Browse )
result = 0
Do While result = 0
	DoEvents
Loop
Phone.SetScreenOrientation(-1)
If result = DialogResponse.POSITIVE Then 
	Return ret
Else
	Return DialogResponse.CANCEL
End If
End Sub

'Shows the dialog and enables multi files selection and browsing.
'Dir - the directory where the list of files is taken from.
'Filter - can be a single string (with the file's extension), or a list of several possible extensions.
'Browse - true if browsing is possible(a button for going up and display of directories).
'The returned value is a list of the selected file names.
'Cancel returns DialogResponse.CANCEL
Public Sub GetSeveralFiles(Dir As String, Filter As Object, Browse As Boolean) As List

Multi = True
input_flag = False
titlelbl.Text = "Get Files"
Show_Common(Dir, Filter , Browse )
result = 0
Do While result = 0
	DoEvents
Loop
If result <> DialogResponse.POSITIVE Then 
	SelList.Clear
	SelList.Add( DialogResponse.CANCEL)
End If
Phone.SetScreenOrientation(-1)
Return SelList
End Sub

'Shows the dialog and enables one file selection or keying the filename to an EditText.
'Dir - the directory where the list of files is taken from.
'Filter - can be a single string (with the file's extension), or a list of several possible extensions.
'Browse - true if browsing is possible(a button for going up and display of directories).
'The returned value is the file name.
'Cancel or empty string will be returned as DialogResponse.CANCEL
Public Sub SetFileName(Dir As String, Filter As Object, Browse As Boolean) As String

Multi = False
input_flag = True
inputet.Text = ""
inputet.background = indw
inputet.TextColor = intextcolor
inputet.Hint = "File name"
titlelbl.Text = "Save File"
Show_Common(Dir, Filter , Browse )
result = 0
Do While result = 0
	DoEvents
Loop
Phone.SetScreenOrientation(-1)
CallSub(MModule,"Hide_Keyboard")
If result = DialogResponse.POSITIVE Then 
	If inputet.Text = "" Then Return DialogResponse.CANCEL
	If PathFlag Then
		Return current_dir & "/" & inputet.text
	Else
		Return inputet.text
	End If
Else
	Return DialogResponse.CANCEL
End If
End Sub

'Shows the dialog and enables keying input to an EditText.
'Returns the content of the EditText as a string.
'Hint will be displayed as a hint.
'InputType  - "D" For Decimal Numbers
'			- "N" For numbers
'			- "P" For Phone
'			- "" or anything else for Text
'Cancel or empty string will be returned as DialogResponse.CANCEL
Public Sub GetInput(Hint As String, Header As String, InputType As String) As String

Multi = False
inputet.Text = ""
inputet.background = indw
inputet.TextColor = intextcolor
inputet.Visible = True
inputet.Hint = Hint
Select InputType
	Case "D", "d"
		inputet.InputType = inputet.INPUT_TYPE_DECIMAL_NUMBERS
	Case "N", "n"
		inputet.InputType = inputet.INPUT_TYPE_NUMBERS
	Case "P", "p"
		inputet.InputType = inputet.INPUT_TYPE_PHONE
	Case Else
		inputet.InputType = inputet.INPUT_TYPE_TEXT
End Select
titlelbl.Text = Header
SV.Visible = False
uplbl.Visible = False
background.Visible = True
background.BringToFront
If AH > AW Then 
	frame.SetLayout(AW/2-200*scale, AH/2-300*scale,400*scale,IH+ 176*scale)
	p.SetLayout(3*scale, 3*scale,394*scale,IH+170*scale)
	Phone.SetScreenOrientation(1)
Else
	frame.SetLayout(AW/2-200*scale, AH/2-175*scale,400*scale,IH+ 176*scale)
	p.SetLayout(3*scale, 3*scale,394*scale,IH+170*scale)
	Phone.SetScreenOrientation(0)
End If

inputet.SetLayout(10*scale ,62*scale,373*scale ,75*scale) 'IH)
'inputet.BringToFront
btn(0).SetLayout(10*scale,p.Height - 80*scale,180*scale,75*scale)
btn(1).SetLayout(204*scale,p.Height - 80*scale,180*scale,75*scale)
result = 0
Do While result = 0
	DoEvents
Loop
Phone.SetScreenOrientation(-1)
CallSub(MModule,"Hide_Keyboard")
If result = DialogResponse.POSITIVE Then 
	If inputet.Text = "" Then Return DialogResponse.CANCEL
	Return inputet.text
Else
	Return DialogResponse.CANCEL
End If
End Sub

Private Sub Show_Common(Dir As String, Filter As Object, Browse As Boolean)
Flist.Clear
current_dir = Dir

If Filter Is String Then
	F_Filter = Filter
	FilterIsString = True
Else
	FilterList = Filter
	FilterIsString = False
End If

SelList.Clear
NumList.Clear
make_list
selected = -1
fill
Set_Layout1
Set_Layout2(Browse)

End Sub

Private Sub Set_Layout1
Dim SVH As Float
Dim size As Int
If input_flag Then size = Flist.size + 1 Else size = Flist.size
If AH > AW Then 
	SVH = Min(size * IH , 500*scale)

	frame.SetLayout(AW/2-200*scale,AH/2-325*scale,400*scale,SVH + 180*scale)
	p.SetLayout(3*scale, 3*scale,394*scale,SVH+174*scale)
	Phone.SetScreenOrientation(1) 
Else
	SVH = Min(size * IH ,250*scale)
	frame.SetLayout(AW/2-200*scale,AH/2-200*scale,400*scale,SVH + 150*scale)
	p.SetLayout(3*scale, 3*scale, 394*scale, SVH + 144*scale)
	Phone.SetScreenOrientation(0)
	SVH = SVH - 25*scale
End If
If input_flag Then
	SV.SetLayout(5*scale,62*scale+IH,380*scale,SVH-IH + 25*scale)
	inputet.SetLayout(10*scale ,57*scale,373*scale ,IH)
	inputet.Visible = True
Else
	SV.SetLayout(5*scale, 62*scale, 380*scale, SVH+ 25*scale)
	inputet.Visible = False
End If
SV.Visible = True
SV.FullScroll(False)
btn(0).SetLayout(10*scale,p.Height - 75*scale,180*scale,70*scale)
btn(1).SetLayout(204*scale,p.Height - 75*scale,180*scale,70*scale)
End Sub

Private Sub Set_Layout2(browse As Boolean)
If browse Then
	uplbl.background = notdr
	uplbl.Visible = True
	uplbl.SetLayout(5*scale,5*scale,115*scale,40*scale)
Else
	uplbl.Visible = False
End If
titlelbl.SetLayout(125*scale,5*scale,260*scale,40*scale)
line.SetLayout(0,50*scale,p.Width,3*scale)
background.Visible = True
background.BringToFront
End Sub

'Sets the colors of Frame, Line and Title text. 
Public Sub SetColors1(FrameColor As Int, LineColor As Int,TitleColor As Int)
frame.Color = FrameColor
line.Color = LineColor
titlelbl.textColor = TitleColor
End Sub

'Sets the color of not-selected text, selected text, gradient top and bottom of not selected item, gradient top and bottom of selected item.
Public Sub SetColors2( NotSelColor As Int,SelColor As Int,top1 As Int, bot1 As Int, top2 As Int, bot2 As Int)

SelTextColor = SelColor
NotTextColor = NotSelColor

notclr(0) = top1
notclr(1) = bot1
notdr.Initialize("TOP_BOTTOM",notclr)
selclr(0) = top2
selclr(1) = bot2
seldr.Initialize("TOP_BOTTOM",selclr)
End Sub

'Sets the colors of the buttons: gradient top and bottom of left button, gradient top and bottom of right button.
Public Sub SetColors3(Btn1top As Int, Btn1bot As Int, Btn2top As Int, Btn2bot As Int,BtnTextColor As Int)
dw1clr(0) = Btn1top
dw1clr(1) = Btn1bot
dw(0).Initialize("TOP_BOTTOM",dw1clr) 

dw2clr(0) = Btn2top
dw2clr(1) = Btn2bot
dw(1).Initialize("TOP_BOTTOM",dw2clr) 
btn(0).TextColor = BtnTextColor
btn(1).TextColor = BtnTextColor
End Sub

'Sets the colors of the input EditText with gradient drawable or one color.
Public Sub SetColors4(Gradient As Boolean, ETtop As Int,ETbot As Int,ETcolor As Int,ETTextColor As Int)
Dim cl() As Int
If Gradient Then
	cl = Array As Int(ETtop,ETbot)
Else
	cl = Array As Int(ETcolor,ETcolor)
End If
indw.Initialize("TOP_BOTTOM",cl)
inputet.background =  indw
intextcolor = ETTextColor
End Sub

Private Sub lbl_click
Dim l As Label

l = Sender
If File.IsDirectory(current_dir, l.Text.Trim) Then
	current_dir = File.Combine(current_dir, l.Text.Trim)
	make_list
	selected = -1
	If Multi Then 
		SelList.clear
		NumList.Clear
	End If
	Set_Layout1
Else
	l.Color = Colors.Yellow
	l.TextColor = Colors.black
	If PathFlag Then
		ret = current_dir & "/" & l.Text.Trim
	Else
		ret = l.text.Trim
	End If
	If input_flag Then inputet.Text = l.Text.Trim
	If Multi Then 
		SelList.Add(ret)
		NumList.add(l.Tag)
	End If
	selected = l.tag
End If
fill
End Sub

Private Sub make_list
Dim list1 As List
Dim st As String

If sortbydate Then
 	Dim fs As FileAndTime
	list1 = ListFilesByDate(current_dir)
	For I = 0 To list1.Size - 1
      fs = list1.Get(I)
    Next
Else
	list1 = File.ListFiles(current_dir)
	list1.Sort(sortdirection)
End If
   
Flist.Clear
For I = 0 To list1.Size - 1
	If sortbydate Then
		fs = list1.Get(I)
		st = fs.Name
	Else
		st = list1.Get(I)
	End If
	If FilterIsString Then
		If File.IsDirectory(current_dir,st) OR st.EndsWith(F_Filter) Then 
			Flist.Add(st)
		End If
	Else
		If File.IsDirectory(current_dir,st) Then 
			Flist.Add(st)
		Else
			For j = 0 To FilterList.Size - 1
				If st.EndsWith(FilterList.Get(j)) Then
					Flist.Add(st)
					Exit
				End If
			Next
		End If
	End If
Next
End Sub

Sub ListFilesByDate(Folder As String) As List
   Dim files As List
   files = File.ListFiles(Folder)
   Dim sortedFiles As List
   sortedFiles.Initialize
   For i = 0 To files.Size - 1
      Dim fs As FileAndTime
      fs.Name = files.Get(i)
      fs.Time = File.LastModified(Folder, fs.Name)
      sortedFiles.Add(fs)
   Next
   sortedFiles.SortType("Time", sortdirection)
   Return sortedFiles
End Sub

Private Sub uplbl_click
current_dir = current_dir.SubString2(0, current_dir.LastIndexOf("/"))
If Multi Then 
	SelList.clear
	NumList.Clear
End If
make_list
selected = -1
fill
Set_Layout1
End Sub

Private Sub fill
Dim lineheight As Int
'Dim Blh As Double
If xs < 5 Then lineheight = IH Else lineheight =  Max(100%x,100%y) / 12
Dim space As String = "  "
SV.Panel.RemoveAllViews
If Flist.Size = 0 Then
	btn(0).Visible = False
Else
	For I = 0 To Flist.Size - 1
		Dim lbl As Label
		lbl.Initialize("lbl")
		SV.Panel.AddView(lbl,5*scale ,I*lineheight,373*scale ,lineheight) 
		If Multi Then
			lbl.background = notdr
			lbl.TextColor = NotTextColor
			If NumList.Size > 0 Then
				For j = 0 To NumList.Size - 1
					If I = NumList.Get(j) Then
						lbl.background = seldr
						lbl.TextColor = SelTextColor
					End If
				Next
			End If
		Else
			If I = selected Then
				lbl.background = seldr
				lbl.TextColor = SelTextColor
			Else
				lbl.background = notdr
				lbl.TextColor = NotTextColor
			End If
		End If
		lbl.Text = space & Flist.Get(I)
		lbl.TextSize = fontsize
		lbl.Gravity = Gravity.CENTER_VERTICAL
		lbl.Tag = I
	Next
	btn(0).Visible = True
End If
SV.Panel.Height =  Flist.Size * lineheight
End Sub

'Returns the object as View (panel)
Public Sub AsView As View
Return background
End Sub

'Sets the font size of the lines.
Public Sub Set_Text_Size(Textsize As Int) ' for the file names text
fontsize = Textsize * Cf '* scale * scale
End Sub

'Sets the frame color
Public Sub Frame_Color(color As Int)
frame.color = color
End Sub

'Sets the line color
Public Sub Line_Color(color As Int)
line.color = color
End Sub

'Default is Descending by Name of file
Public Sub SetSort(ByDate As Boolean, Ascending As Boolean)
If ByDate Then sortbydate = True Else sortbydate = False
If Ascending Then sortdirection = True Else sortdirection = False
End Sub

Private Sub button_click
Dim B As Button
B = Sender
result = B.Tag
background.Visible = False
End Sub

Private Sub background_click
End Sub

Private Sub background_long_click
End Sub
