﻿Type=Class
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module

'code to put in the calling activity:
'************************************************************
' declare your msg object in globals
'
'Sub Activity_Resume
'mymsg.initialize(Me, "mymsg", Colors.black ,Colors.yellow, 24, Colors.White, 20 ,Colors.black, Activity)
'mymsg.SetScale(1.2) ' optional
'end sub
'
'Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event
'If KeyCode = KeyCodes.KEYCODE_BACK Then
'	 mymsg.set_type(False)
'    mymsg.Show("Exit","Do you want to exit ?",	LoadBitmap(File.DirAssets,"Warning-icon.png"),"Yes","", "No")
'End If
'Return True
'End Sub
'
'Sub mymsg_results(result As Int)
'If result = DialogResponse.POSITIVE Then Activity.Finish
'mymsg.set_type(True)  ' critical to return the type to true for other messages.
'End Sub
'
'use: 
'if mymsg.Show("Vote","Do you like this message ?",	LoadBitmap(File.DirAssets,"warningicon.png"),"Yes","Cancel", "No") = DialogResponse.POSITIVE Then...
'
'middle or right buttons will not appear if their text is "" .

'*****************************************************************************
'Note: use only after activity_resume is done, otherwise it is ignored by the OS.
'*************************************************************************
Sub Class_Globals
Private MModule As Object
Private background,frame , p, line  As Panel	
Private btn(3) As Button
Private titlelbl, msglbl As Label
Private iv As ImageView
Private result As Int = 0
Private SF, SZ As Float 
Private ModalMsg As Boolean = True ' not using the return sub in the main activity
Private event As String
Private AW, AH , mx, my As Int

End Sub

'Initializes the object.
Public Sub Initialize(Module As Object, Eventname As String,FrameColor As Int, TitleColor As Int, TitleSize As Int, MsgColor As Int, MsgSize As Int,LineColor As Int, Parent As Activity)

AW = Parent.Width
AH = Parent.Height
mx = 50%x
my = 42.5%Y

Dim clr(2) As Int
Dim dw As GradientDrawable

'SF =  1.2 * Max(AW,AH)/800/Density 
'scale = SF

Dim lv As LayoutValues
lv = GetDeviceLayoutValues
SZ = lv.ApproximateScreenSize
If SZ > 6 Then SF = 6/SZ Else SF = 1
MModule = Module
event = Eventname
background.Initialize("bg")
Parent.AddView(background, 0,0,100%x,100%y)
frame.Initialize("")
iv.Initialize("")
p.Initialize("")
line.Initialize("")
titlelbl.Initialize("")
msglbl.Initialize("")

background.Color = Colors.ARGB(170,0,0,0)
frame.Color = FrameColor
p.Color = Colors.DarkGray
titlelbl.TextSize = TitleSize + 3* (SZ-5)
titlelbl.TextColor = TitleColor
titlelbl.Gravity = Gravity.CENTER
msglbl.TextSize = MsgSize + 3* (SZ-5)
msglbl.TextColor = MsgColor
msglbl.Gravity = Gravity.CENTER
line.Color = LineColor
clr(0) = Colors.white
clr(1) = Colors.RGB(80,80,80)
dw.Initialize("TOP_BOTTOM",clr)
dw.CornerRadius = 5dip
For i = 0 To 2
	btn(i).Initialize("button")
	btn(i).background = dw
	btn(i).TextSize =  MsgSize + 3*(SZ-5)
	btn(i).Textcolor = Colors.black
Next
btn(0).Tag = DialogResponse.POSITIVE
btn(1).Tag = DialogResponse.CANCEL
btn(2).Tag = DialogResponse.NEGATIVE

iv.Gravity = Gravity.FILL
If AH>AW Then
	mx = 50%x
	my = 42.5%Y
	background.AddView(frame,mx-35%x, my - 17.5%y, 70%x,35%y)
	frame.AddView(p,0, 0,70%x,35%y)
	my = p.Height/2
	p.AddView(iv,mx-47%x,my-17%y,10%x,10%x)
	p.AddView(titlelbl,mx-35%x,my-16%y,60%x,10%x)
	p.AddView(line,0,my-9.5%y,p.Width,0.5%y)
	p.AddView(msglbl,mx-46%x,my-8.5%y,62%x,15%y)
	p.AddView(btn(0),mx-47.5%x,my+9%y,20%x,7%y)
	p.AddView(btn(1),mx-25%x,my +9%y,20%x,7%y)
	p.AddView(btn(2),mx-2.5%x,my +9%y,20%x,7%y)
Else
	mx = 50%x
	my = 42.5%Y
	background.AddView(frame,mx-22%x, my - 30%y, 44%x,60%y)
	frame.AddView(p,0, 0,42%x,60%y)
	my = p.Height/2
	mx = p.Width/2
	p.AddView(iv,mx-20%x,my-27.5%y,6%x,6%x)
	p.AddView(titlelbl,mx-13%x,my-26%y,36%x,6%x)
	p.AddView(line,0,my-14%y,p.Width,0.8%y)
	p.AddView(msglbl,mx-19%x,my-12%y,40%x,15%y)
	p.AddView(btn(0),mx-20%x,my+14.5%y,12%x,13%y)
	p.AddView(btn(1),mx-6%x,my +14.5%y,12%x,13%y)
	p.AddView(btn(2),mx+8%x,my +14.5%y,12%x,13%y)
End If
SetScale(1.3)
background.Visible = False
End Sub

'If True - will not use the return sub in the main activity, but return the call from  "Show" .
Public Sub set_type(Modal As Boolean)
ModalMsg = Modal 
End Sub



'If midtext or righttext are passed as "" - the buttons will not show.
Public Sub Show(Title As String, Text As String, Bitmap As Bitmap, LeftText As String, MidText As String, RightText As String) As Int 'ignore
titlelbl.Text = Title
msglbl.Text = Text
btn(0).Text = LeftText

If AH>AW Then
	If MidText = "" Then
		btn(1).Visible = False
		If RightText = "" Then
			btn(2).Visible = False
			btn(0).Left = SF*mx-SF*30%x
			btn(0).Width = SF*30%x
		Else
			btn(0).SetLayout(mx-SF*33%x,SF*my+SF*9%y,SF*25%x,SF*7%y)
			btn(2).SetLayout(mx+SF*1%x,SF*my+SF*9%y,SF*25%x,SF*7%y)
			btn(2).Text = RightText
			btn(2).Visible = True
		End If
	Else
		btn(0).SetLayout(SF*(mx-47.5%x),SF*my+SF*9%y, SF*20%x, SF*7%y)
		btn(1).SetLayout(SF*(mx-25%x),  SF*my+SF*9%y, SF*20%x, SF*7%y)
		btn(2).setlayout(SF*(mx-2.5%x), SF*my+SF*9%y, SF*20%x, SF*7%y)
		btn(1).Text = MidText
		btn(2).Text = RightText
		btn(1).Visible = True
		btn(2).Visible = True
	End If 
Else
	If MidText = "" Then
		btn(1).Visible = False
		If RightText = "" Then
			btn(2).Visible = False
			btn(0).Left = SF*(mx-8%x)
			btn(0).Width = SF*16%x
		Else
			btn(0).SetLayout(SF*(mx-17%x),SF*my+SF*14.5%y,SF*15%x,SF*13%y)
			btn(2).SetLayout(SF*(mx+4%x),SF*my+SF*14.5%y,SF*15%x,SF*13%y)
			btn(2).Text = RightText
			btn(2).Visible = True
		End If
	Else
		btn(0).SetLayout(SF*(mx-20%x),SF*my+SF*14.5%y,SF*12%x,SF*13%y)
		btn(1).SetLayout(SF*(mx-5%x), SF*my+SF*14.5%y,SF*12%x,SF*13%y)
		btn(2).SetLayout(SF*(mx+10%x), SF*my+SF*14.5%y,SF*12%x,SF*13%y)
		btn(1).Text = MidText
		btn(2).Text = RightText
		btn(1).Visible = True
		btn(2).Visible = True
	End If 
End If
If Bitmap.IsInitialized Then
	iv.Bitmap = Bitmap
	iv.Visible = True
	If AH>AW Then
		titlelbl.Left = SF*mx-SF*35%x
		titlelbl.Width = SF*60%x
	Else
		titlelbl.Left = SF*mx-SF*13%x
		titlelbl.width = SF*36%x
	End If
	titlelbl.Gravity = Gravity.LEFT
Else
	iv.Visible = False
	If AH>AW Then
		titlelbl.Left = SF*mx-SF*45%x
		titlelbl.Width = SF*60%x
	Else
		titlelbl.Left = SF*mx-SF*19%x
		titlelbl.width = SF*38%x
	End If
	titlelbl.Gravity = Gravity.CENTER_HORIZONTAL
End If
background.Visible = True
background.BringToFront
If ModalMsg Then
	result = 0
	Do While result = 0
		DoEvents
	Loop
	Return result
End If
End Sub

'Returns the background panel as a view
Public Sub AsView As View
Return background
End Sub

'Sets the TextSize of the message
Public Sub Set_Button_Font_Size(FontSize As Int)
For i = 0 To 2
	btn(i).TextSize = FontSize + 3*(SZ-5)
Next
End Sub

'Sets the color of the frame
Public Sub Frame_Color(color As Int)
frame.color = color
End Sub

'Sets the color of the line between the title and the message
Public Sub Line_Color(color As Int)
line.color = color
End Sub

Private Sub button_click
Dim B As Button
B = Sender
result = B.Tag
If ModalMsg = False Then CallSub2(MModule,event & "_results",result)
background.Visible = False

End Sub

Private Sub bg_click
End Sub

Private Sub bg_long_click
End Sub

'Increase or Decrease the dialog size, but keeps it centered. SizeFactor = 1 is no change.
Private Sub SetScale(SizeFactor As Float)
	SF = SizeFactor 
	If AH>AW Then
		frame.SetLayout(50%x-SF*35%x, 42.5%y -SF* 17.5%y, SF*70%x, SF*35%y)
		Dim smx As Int = frame.Width/2
		Dim smy As Int = frame.Height/2
		p.SetLayout(smx-SF*35%x, smy -SF* 17.5%y, SF*70%x, SF*35%y)
	Else
		frame.SetLayout(50%x-SF*22%x, 42.5%y - SF*30%y, SF*44%x,SF*60%y)
		Dim smx As Int = frame.Width/2
		Dim smy As Int = frame.Height/2
		p.SetLayout(smx-SF*22%x, smy -SF* 30%y, SF*44%x, SF*60%y)
	End If
	Dim v As View
	For i = 0 To p.NumberOfViews -1
		v = p.GetView(i)
		v.SetLayout( v.left * SF , v.top * SF, v.width * SF ,  v.height * SF ) 
	Next
End Sub




